commit 1788588589a534dd9b732f1ddec10aefd5d689db
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Thu Nov 20 08:19:32 2025

    c++: Fix error recovery ICE in tsubst_baselink [PR120876]
    
    The following testcase ICEs since r12-6080.  The problem is that
    lookup_fnfields can return NULL_TREE on failure, but the maybe_incomplete
    handling was added before the if (!baselink) handling and assumes that
    baselink is non-NULL (and BASELINK).
    
    The following patch reorders the if (maybe_incomplete) handling with
    if (!baselink).
    
    2025-11-20  Jakub Jelinek  <jakub@redhat.com>
    
            PR c++/120876
            * pt.cc (tsubst_baselink): Move maybe_incomplete handling after
            !baselink handling.
    
            * g++.dg/parse/crash81.C: New test.
    
    (cherry picked from commit 6bace0ed49aea613ccd6c4f3c21a9ef0473fe62b)

diff --git a/gcc/testsuite/g++.dg/parse/crash81.C b/gcc/testsuite/g++.dg/parse/crash81.C
new file mode 100644
index 00000000000..632ab042810
--- /dev/null
+++ b/gcc/testsuite/g++.dg/parse/crash81.C
@@ -0,0 +1,14 @@
+// PR c++/120876
+// { dg-do compile { target c++11 } }
+
+template <typename T>
+struct S {
+  static bool foo (decltype (bar (T {})));	// { dg-error "'bar' was not declared in this scope; did you mean 'baz'\\\?" }
+  static constexpr bool s = foo (0);
+};
+
+void
+baz ()
+{
+  S <int>::s;
+}

